#ifndef _GPU_SUPPORT_MANAGER_H
#define _GPU_SUPPORT_MANAGER_H

#define GL_GLEXT_PROTOTYPES
#include <EGL/egl.h>
#include "GLES2/gl2.h"
#include "EGLTypes.h"
#include "ApplicationModel.h"




class GPUCodeManager {
	
	public:
	GPUCodeManager(ApplicationModel &m);
		void createShaderAndProgram(EGL_STATE_T* state);
		void init_shaders(EGL_STATE_T* state);
		bool loadAndCompileShader(const char* fileName, GLuint& shaderId, GLenum shaderType);
		
		void drawScene(EGL_STATE_T *state);
    private:
		GLint attrLocVertex;
		GLint uniformLocCenter;
		GLint uniformLocScale;
		GLint uniformLocAlpha;
		static const char* className;
		ApplicationModel &model;
};

#endif 
