#ifndef MAIN_WINDOW_H
#define MAIN_WINDOW_H

#include <gtkmm/adjustment.h>
#include <gtkmm/box.h>
#include <gtkmm/scale.h>
#include <gtkmm/window.h>
#include "ApplicationModel.h"
#include "OpenGLSceneView.h"

class MainWindow :  public Gtk::Window  {

    public:
        MainWindow(Glib::RefPtr<Gtk::Application> app, ApplicationModel& m);
        virtual ~MainWindow();

    protected:
        bool onDeleteEvent(GdkEventAny* event);
        bool onButtonReleaseEvent(GdkEventButton *crossingEvent);
        
    private:
        ApplicationModel& model;
        Gtk::Scale reglerScale;
        Gtk::Scale reglerAngle;
        OpenGLSceneView glView;
        Gtk::Box container;
        
};

#endif
