#ifndef OPEN_GL_SCENE_VIEW_H
#define OPEN_GL_SCENE_VIEW_H

#include <gtkmm/drawingarea.h>
#define GL_GLEXT_PROTOTYPES
#include <GLES2/gl2.h>
#include <iostream>
//#include <assert.h>

#include "EGLTypes.h"
#include "GPUCodeManager.h"

class OpenGLSceneView  : public Gtk::DrawingArea{

  public:
     OpenGLSceneView(ApplicationModel &m);
     ~OpenGLSceneView();
     

     virtual bool on_configure_event(GdkEventConfigure* event);
     virtual bool on_draw(const Cairo::RefPtr<Cairo::Context> &context);
     void refresh();

  private:

     EGL_STATE_T _state;
     EGL_STATE_T *state;
     unsigned char* imageBuffer;
     
     GPUCodeManager gpu;
     
     void redraw_scene(EGL_STATE_T* state);

};



#endif
