#version 100
precision highp float;    //  Raspberry verlangt das nicht 
#define MAX_IT 30
#define MIN_DIST 0.005


uniform vec2 center;
uniform vec2 scale;
uniform float alpha;  //  in Grad

vec2 sol1;
vec2 sol2;
vec2 sol3;
vec2 c1;
//vec2 c2;
vec2 c3;

vec2 mul(vec2 c1, vec2 c2) {
	return vec2(c1.x*c2.x - c1.y*c2.y,
	            c1.x*c2.y + c1.y*c2.x 
	           );
}

vec2 div(vec2 c1, vec2 c2) {
	float d = c2.x*c2.x + c2.y*c2.y;
	return vec2((c1.x*c2.x + c1.y*c2.y)/d,
	            (c1.y*c2.x - c1.x*c2.y)/d
	           );
}


void main() {
	vec4 fcolor/* = vec4(1.0, 1.0, 0.0, 1.0) */;
	vec2 x;
	vec2 xNeu;
	vec2 f;
	vec2 df;
	vec2 quotient;
	float cr = (gl_FragCoord.x - center.x)*scale.x;
	float ci = (gl_FragCoord.y - center.y)*scale.y;
	x = vec2(cr, ci);
	float m;
	int iMax;
	
	sol1 = vec2(-1.0, 0.0);
    sol2 = vec2(cos(radians(alpha)), sin(radians(alpha)));
    sol3 = vec2(cos(radians(alpha)), -sin(radians(alpha)));
    c1 = vec2(1.0 - 2.0*cos(radians(alpha)), 0);
    // c2 = vec2( 1.0 + 2.0*cos(radians(alpha)), 0);
    c3 = vec2(1.0, 0.0);

	for (int i = 0; i < MAX_IT; i++) {
		f = x + c1;
		df = x + f;
		f  = mul(f, x) + c1;
		df = mul (df, x) + f;
		f  = mul(f, x) + c3;
		
		xNeu = x - div(f, df);
		x = xNeu;
        iMax = i;
		if (distance(x, sol1) < MIN_DIST) {
			break;
		} else if (distance(x, sol2) < MIN_DIST) {
			break;
		} else if (distance(x, sol3) < MIN_DIST) {
			break;
		}
	}
	iMax =  3*((iMax + 1)/3);
	m = float(MAX_IT + 4)/float(MAX_IT  + 4- iMax);
	if (distance(x, sol1) < MIN_DIST) {
		fcolor = vec4 (0.65*m, 0.2*m, 0.2*m, 1.0);
	} else if (distance(x, sol2) < MIN_DIST) {
		fcolor = vec4 (0.2*m, 0.65*m, 0.2*m, 1.0);
	} else if (distance(x, sol3) < MIN_DIST) {
		fcolor = vec4 (0.2*m + 0.1, 0.2*m +0.1, 0.65*m, 1.0);
	} 
    //fcolor = vec4 (0.8, cr > 0.0 ? 0.8 : 0.0, ci > 0.0 ? 0.8 : 0.0, 1.0);
    gl_FragColor = fcolor;

}
