#include "ApplicationModel.h"

ApplicationModel::ApplicationModel(Glib::RefPtr<Gtk::Application> a) : 
     app(a),  
     adjustmentScale (Gtk::Adjustment::create(10.0, 3.0, 100.0, 1.0, 1.0, 1.0)),  
     adjustmentAngle (Gtk::Adjustment::create(60.0, 5.0, 176.0, 0.5, 0.5, 1.0))
        // value, lower value, upper value, step increment, page increment, page size
        //  Adjustments werden mit der statischen Methode  create hergestellt,
        //  die das Objekt in einem Glin::RefPtr verpackt liefert.
        //  Der Konstruktor von Adjustment ist protected und deshalb hier
        //  nicht verwendbar. 
{
	
}

Glib::RefPtr<Gtk::Adjustment> ApplicationModel::getAdjustmentScale() {
	return adjustmentScale;
}

double ApplicationModel::getZoomValue() {
	return adjustmentScale -> get_value();
}


Glib::RefPtr<Gtk::Adjustment> ApplicationModel::getAdjustmentAngle() {
	return adjustmentAngle;
}

double ApplicationModel::getAngle() {
	return adjustmentAngle -> get_value();
}
