#include "GLES20ErrorHandler.h"
#include <cstdio>  // für printf
#define GL_GLEXT_PROTOTYPES
#include "GLES2/gl2.h" 

bool GLES20ErrorHandler::checkError(char const* cl, char const* method, char const* fn) {
	const char *fmtString = "%s in class: %s method: %s arg: %s\n";
	GLenum errorCode;
	errorCode = glGetError();
    switch (errorCode) { /*
		case GL_NO_ERROR:
		   printf(fmtString, "GL_NO_ERROR", cl, method, fn);
		   break;  */
		case GL_INVALID_ENUM:
		   printf(fmtString, "GL_INVALID_ENUM", cl, method, fn);
		   break;
		case GL_INVALID_VALUE:
		   printf(fmtString, "GL_INVALID_VALUE", cl, method, fn);
		   break;
		case GL_INVALID_OPERATION:
		   printf(fmtString, "GL_INVALID_OPERATION", cl, method, fn);
		   break;
		case GL_INVALID_FRAMEBUFFER_OPERATION:
		   printf(fmtString, "GL_INVALID_FRAMEBUFFER_OPERATION", cl, method, fn);
		   break;
		case GL_OUT_OF_MEMORY:
		   printf(fmtString, "GL_OUT_OF_MEMORY", cl, method, fn);
		   break;
	}
	return errorCode != GL_NO_ERROR;
}
