#include "MainWindow.h"
#include <gdkmm/event.h>
#include <GLES2/gl2.h>


/*
 * Der Bildaufbau ist so langsam, dass es nicht sinnvoll ist, auf jede
 * Änderung des Reglerwertes zu reagieren. Es wird erst reagiert, wenn
 * die Maustaste losgelassen wird.
 */
MainWindow::MainWindow(Glib::RefPtr<Gtk::Application> app, ApplicationModel& m) :

   model(m),
   reglerScale(m.getAdjustmentScale(),  Gtk::ORIENTATION_VERTICAL),
   reglerAngle(m.getAdjustmentAngle(),  Gtk::ORIENTATION_VERTICAL),
   glView(model),
   container(Gtk::ORIENTATION_HORIZONTAL, 2)
{
	
	set_title("OpenGL ES 2.0 Fraktal Painter");
    set_position(Gtk::WIN_POS_CENTER);
    set_reallocate_redraws(true); 
    set_default_size(590, 520);
    signal_delete_event().
	     connect(sigc::mem_fun(*this, &MainWindow::onDeleteEvent));
	container.set_border_width(10);
   add(container);
   reglerScale.set_inverted();
   reglerScale.set_draw_value(false);
   reglerScale.set_events(Gdk::BUTTON_RELEASE_MASK);
   reglerAngle.set_inverted();
   reglerAngle.set_draw_value(true);
   reglerAngle.set_events(Gdk::BUTTON_RELEASE_MASK);
   reglerAngle.set_size_request(64, -1);  // Breite vorgeschrieben, Höhe frei
   
   container.pack_start(reglerScale, Gtk::PACK_SHRINK);
   container.pack_start(glView);
   container.pack_start(reglerAngle, Gtk::PACK_SHRINK);
   reglerScale.signal_button_release_event().
            connect(sigc::mem_fun(*this, &MainWindow::onButtonReleaseEvent), false);
   reglerAngle.signal_button_release_event().
            connect(sigc::mem_fun(*this, &MainWindow::onButtonReleaseEvent), false);
   reglerScale.show();
   glView.show();
   reglerAngle.show();
   container.show();
   show();
}

MainWindow::~MainWindow() {
}

bool MainWindow::onButtonReleaseEvent(GdkEventButton *crossingEvent) {
	glView.refresh();
	return false;
}

bool MainWindow::onDeleteEvent(GdkEventAny* event) {
	return false;  // Weiterbehandlung zulassen
};
